#ifndef INDLL_H
#define INDLL_H

#include <string>
#include <qr_invoice_simple_defs.hpp>

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfJson(
        const char* Language, const char* PageSize,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfJsonBase64(
        const char* Language, const char* PageSize,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPdfCsv(
    const char* Language, const char* PageSize,
    bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
    const char* CsvInput,
    char *OutputBuffer, unsigned long *OutputBufferSize,
    char *MessageBuffer, unsigned long *MessageBufferSize
);
QRINVOICE_SIMPLE_API unsigned int CreatePprPdfCsvBase64(
    const char* Language, const char* PageSize,
    bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
    const char* CsvInput,
    char *OutputBuffer, unsigned long *OutputBufferSize,
    char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngJson(
        const char* Language, const char* PageSize,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngJsonBase64(
        const char* Language, const char* PageSize,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreatePprPngCsv(
        const char* Language, const char* PageSize,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);
QRINVOICE_SIMPLE_API unsigned int CreatePprPngCsvBase64(
        const char* Language, const char* PageSize,
        bool BoundaryLines, bool BoundaryLineScissors, bool BoundaryLineSeparationText,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateQrCodePngJson(
        const unsigned DesiredQrCodeSize,
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateQrCodePngJsonBase64(
        const unsigned DesiredQrCodeSize,
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateQrCodePngCsv(
        const unsigned DesiredQrCodeSize,
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateQrCodePngCsvBase64(
        const unsigned DesiredQrCodeSize,
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcJson(
        const char* JsonInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcJsonBase64(
        const char* JsonInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcCsv(
        const char* CsvInput,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int CreateSpcCsvBase64(
        const char* CsvInputBase64,
        char *OutputBuffer, unsigned long *OutputBufferSize,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateJson(
        const char* JsonInput,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateJsonBase64(
        const char* JsonInputBase64,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateCsv(
        const char* CsvInput,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API unsigned int ValidateCsvBase64(
        const char* CsvInputBase64,
        char *MessageBuffer, unsigned long *MessageBufferSize
);

QRINVOICE_SIMPLE_API const bool ValidateString(const char* String);

QRINVOICE_SIMPLE_API const bool ValidateStringBase64(const char* StringBase64);

QRINVOICE_SIMPLE_API const bool ValidateIBAN(const char* IBAN, const bool ValidateCountryCode);

QRINVOICE_SIMPLE_API const bool ValidateQrIBAN(const char* IBAN);

QRINVOICE_SIMPLE_API const bool ValidateQrReference(const char* QrReference);

QRINVOICE_SIMPLE_API const bool ValidateCreditorReference(const char* CreditorReference);

QRINVOICE_SIMPLE_API const bool ValidateCountryCode(const char* CountryCode);

#endif